"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

exports.default = applyRules;

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _propTypes = require("prop-types");

var _propTypes2 = _interopRequireDefault(_propTypes);

var _deepEqual = require("deep-equal");

var _deepEqual2 = _interopRequireDefault(_deepEqual);

var _utils = require("./utils");

var _runRules = require("./runRules");

var _runRules2 = _interopRequireDefault(_runRules);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function applyRules(FormComponent) {
  var FormWithConditionals = function (_Component) {
    _inherits(FormWithConditionals, _Component);

    function FormWithConditionals(props) {
      _classCallCheck(this, FormWithConditionals);

      var _this = _possibleConstructorReturn(this, (FormWithConditionals.__proto__ || Object.getPrototypeOf(FormWithConditionals)).call(this, props));

      _initialiseProps.call(_this);

      var _this$props = _this.props,
          schema = _this$props.schema,
          uiSchema = _this$props.uiSchema,
          formData = _this$props.formData;

      _this.state = { schema: schema, uiSchema: uiSchema, formData: formData };

      _this.runRulesOnRender = true;
      return _this;
    }

    _createClass(FormWithConditionals, [{
      key: "componentWillReceiveProps",
      value: function componentWillReceiveProps(nextProps) {
        var schema = nextProps.schema,
            formData = nextProps.formData,
            uiSchema = nextProps.uiSchema;

        this.setState({ schema: schema, formData: formData, uiSchema: uiSchema });
        this.runRulesOnRender = this.runRulesOnRender || !(0, _deepEqual2.default)(nextProps, this.props);
      }
    }, {
      key: "shouldComponentUpdate",
      value: function shouldComponentUpdate(nextProps, nextState) {
        if (!(0, _deepEqual2.default)(nextState.schema, this.state.schema)) {
          return true;
        }
        if (!(0, _deepEqual2.default)(nextState.formData, this.state.formData)) {
          return true;
        }
        if (!(0, _deepEqual2.default)(nextState.uiSchema, this.state.uiSchema)) {
          return true;
        }
        return !(0, _deepEqual2.default)(nextProps, this.props);
      }
    }, {
      key: "render",
      value: function render() {
        var _state = this.state,
            schema = _state.schema,
            uiSchema = _state.uiSchema,
            formData = _state.formData;

        var configs = Object.assign({}, this.props, {
          schema: schema,
          uiSchema: uiSchema,
          formData: formData,
          onChange: this.ruleTracker
        });

        if (this.runRulesOnRender) {
          this.runRulesOnRender = false;
          var self = this;
          (0, _runRules2.default)(this.state.formData, this.props).then(function (newState) {
            return self.setState(newState);
          });
        }

        return _react2.default.createElement(FormComponent, configs);
      }
    }]);

    return FormWithConditionals;
  }(_react.Component);

  var _initialiseProps = function _initialiseProps() {
    var _this2 = this;

    this.ruleTracker = function (state) {
      var formData = state.formData;

      (0, _runRules2.default)(formData, _this2.props).then(function (newSchemaConf) {
        _this2.notifySchemaUpdate(newSchemaConf, _this2.state);
        _this2.setState(Object.assign({}, newSchemaConf));
        if (_this2.props.onChange) {
          _this2.props.onChange(Object.assign({}, state, newSchemaConf));
        }
      });
    };

    this.notifySchemaUpdate = function (nextSchemaConf, schemaConf) {
      if (_this2.props.onSchemaConfChange === undefined) {
        return;
      }

      var schemaChanged = !(0, _deepEqual2.default)(nextSchemaConf.schema, schemaConf.schema) || !(0, _deepEqual2.default)(nextSchemaConf.uiSchema, schemaConf.uiSchema);

      if (schemaChanged) {
        _this2.props.onSchemaConfChange(nextSchemaConf, schemaConf);
      }
    };
  };

  if ((0, _utils.isDevelopment)()) {
    FormWithConditionals.propTypes = {
      rulesEngine: _propTypes2.default.object.isRequired,
      rules: _propTypes2.default.arrayOf(_propTypes2.default.shape({
        conditions: _propTypes2.default.object.isRequired,
        event: _propTypes2.default.shape({
          type: _propTypes2.default.string.isRequired
        })
      })).isRequired,
      onSchemaConfChange: _propTypes2.default.func,
      extraActions: _propTypes2.default.object
    };
  }

  return FormWithConditionals;
}